public class InterviewQuestion {
    public String reverseWords(String input) {


      /**
	 * This function takes a space separated string of words and
	 * reverses the word order. So if the input string is
	 * "foo bar baz" the function will return "baz bar foo".
	 * 
	 * @param input a space separated string of words
	 * @return a space separated string of words in reverse
      * order from the input
	 */

      String retStr = new String();
      input = input.trim();
      int iptr;

      if (input.length() > 0) {      
        do {
          iptr = input.lastIndexOf(" ");    
          if (iptr > -1) { 
            retStr = retStr + input.substring(iptr+1) + " "; 
            input = input.substring(0,iptr);
            input = input.trim();
          } else {
            iptr = -1;
            retStr = retStr + input;
          }
        } while (iptr > 0); 
      }
      return retStr;
    }  


    public static void main(String[] args)  {
      InterviewQuestion rob = new InterviewQuestion();
      System.out.println("The result should be zero for all of these tests.");

      String robOut = 
          new String (rob.reverseWords("Now is the time"));
      System.out.println(robOut.compareTo("time the is Now"));

      robOut = 
          new String (rob.reverseWords("Now"));
      System.out.println(robOut.compareTo("Now"));

      robOut = 
          new String (rob.reverseWords(""));
      System.out.println(robOut.compareTo(""));

      robOut = 
          new String (rob.reverseWords(" "));
      System.out.println(robOut.compareTo(""));

      robOut = 
          new String (rob.reverseWords("  "));
      System.out.println(robOut.compareTo(""));

      robOut = 
          new String (rob.reverseWords("Now cow"));
      System.out.println(robOut.compareTo("cow Now"));

      robOut = 
          new String (rob.reverseWords(" Now is the time"));
      System.out.println(robOut.compareTo("time the is Now"));

      robOut = 
          new String (rob.reverseWords(" Now is the time "));
      System.out.println(robOut.compareTo("time the is Now"));

      robOut = 
          new String (rob.reverseWords("Now is the time "));
      System.out.println(robOut.compareTo("time the is Now"));

      robOut = 
          new String (rob.reverseWords(" Now  is the time "));
      System.out.println(robOut.compareTo("time the is Now"));
    }
}